package hhc_common

import "fmt"

type SDTWalkError interface {
	FES() string // Friendly Error String
	EES() string // Expert Error String
}

type SDTWalkError_NullPointerException struct {
	RelyToken  string
	RelyEntity string
}

func (e SDTWalkError_NullPointerException) FES() string {
	return "go-hhc-cli parser internal error"
}

func (e SDTWalkError_NullPointerException) EES() string {
	return fmt.Sprint("null pointer exception. rely token:", e.RelyToken, "rely entity:", e.RelyEntity)
}

type SDTWalkError_UnrecognizedCommand struct {
	RelyToken string
}

func (e SDTWalkError_UnrecognizedCommand) FES() string {
	return fmt.Sprint("unrecognized command: ", e.RelyToken)
}

func (e SDTWalkError_UnrecognizedCommand) EES() string {
	return fmt.Sprint("unrecognized command: ", e.RelyToken)
}

type SDTWalkError_RootNodeCannotFallback struct {
}

func (e SDTWalkError_RootNodeCannotFallback) FES() string {
	return "go-hhc-cli parser internal error"
}

func (e SDTWalkError_RootNodeCannotFallback) EES() string {
	return "root node can not fallback"
}

type SDTWalkError_IncompleteCommand struct {
}

func (e SDTWalkError_IncompleteCommand) FES() string {
	return "incomplete command"
}

func (e SDTWalkError_IncompleteCommand) EES() string {
	return "incomplete command"
}

type SDTWalkError_LossingParent struct {
	RelyName string
}

func (e SDTWalkError_LossingParent) FES() string {
	return "go-hhc-cli parser internal error"
}

func (e SDTWalkError_LossingParent) EES() string {
	return fmt.Sprint("lossing parent for", e.RelyName)
}

type SDTWalkError_TooManyParameters struct {
}

func (e SDTWalkError_TooManyParameters) FES() string {
	return "too many parameters"
}

func (e SDTWalkError_TooManyParameters) EES() string {
	return "too many parameters"
}

type SDTWalkError_TooShortPrefix struct {
}

func (e SDTWalkError_TooShortPrefix) FES() string {
	return "your input prefix too short so it means multiple selection"
}

func (e SDTWalkError_TooShortPrefix) EES() string {
	return "too short prefix"
}
